Index: /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/ConcurrentRestServiceTest.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/ConcurrentRestServiceTest.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/ConcurrentRestServiceTest.java	(revision 5549)
@@ -1,4 +1,5 @@
 package clarin.cmdi.componentregistry.rest;
 
+import clarin.cmdi.componentregistry.RegistrySpace;
 import clarin.cmdi.componentregistry.impl.database.ComponentRegistryTestDatabase;
 import clarin.cmdi.componentregistry.model.BaseDescription;
@@ -20,5 +21,4 @@
 
 import org.junit.Before;
-import org.junit.BeforeClass;
 import org.junit.Test;
 import org.slf4j.Logger;
@@ -27,5 +27,5 @@
 import org.springframework.jdbc.core.JdbcTemplate;
 
-import static clarin.cmdi.componentregistry.rest.ComponentRegistryRestService.USERSPACE_PARAM;
+import static clarin.cmdi.componentregistry.rest.ComponentRegistryRestService.REGISTRY_SPACE_PARAM;
 import static org.junit.Assert.*;
 
@@ -58,9 +58,11 @@
 	List<Thread> ts = new ArrayList<Thread>();
 
-	registerProfiles(ts, NR_OF_PROFILES, errors, false);
-	registerProfiles(ts, NR_OF_PROFILES, errors, true);
-
-	registerComponents(ts, NR_OF_COMPONENTS, errors, false);
-	registerComponents(ts, NR_OF_COMPONENTS, errors, true);
+	registerProfiles(ts, NR_OF_PROFILES, errors, RegistrySpace.PRIVATE);
+        //a profile can be first registered (created) only in private space, and then moved.
+	//registerProfiles(ts, NR_OF_PROFILES, errors, RegistrySpace.PUBLISHED);
+
+	registerComponents(ts, NR_OF_COMPONENTS, errors, RegistrySpace.PRIVATE);
+	//a profile can be first registered (created) only in private space, and then moved.
+        //registerComponents(ts, NR_OF_COMPONENTS, errors, RegistrySpace.PUBLISHED);
 	runAllThreads(ts);
 	if (errors.size() > 0) {
@@ -70,15 +72,15 @@
 	    fail();
 	}
-	assertProfiles(NR_OF_PROFILES, false);
-	assertProfiles(NR_OF_PROFILES, true);
-
-	assertComponents(NR_OF_COMPONENTS, false);
-	assertComponents(NR_OF_COMPONENTS, true);
-    }
-
-    private void assertProfiles(int nrOfProfiles, boolean userSpace) {
+	assertProfiles(NR_OF_PROFILES, RegistrySpace.PRIVATE);
+	//assertProfiles(NR_OF_PROFILES, RegistrySpace.PUBLISHED);
+
+	assertComponents(NR_OF_COMPONENTS, RegistrySpace.PRIVATE);
+	//assertComponents(NR_OF_COMPONENTS, RegistrySpace.PUBLISHED);
+    }
+
+    private void assertProfiles(int nrOfProfiles, RegistrySpace registrySpace) {
 	List<ProfileDescription> response = getAuthenticatedResource(
 		getResource().path("/registry/profiles").queryParam(
-			USERSPACE_PARAM, "" + userSpace)).accept(
+			REGISTRY_SPACE_PARAM, registrySpace.name())).accept(
 		MediaType.APPLICATION_XML).get(PROFILE_LIST_GENERICTYPE);
 	Collections.sort(response, descriptionComparator);
@@ -101,8 +103,8 @@
     };
 
-    private void assertComponents(int nrOfComponents, boolean userSpace) {
+    private void assertComponents(int nrOfComponents, RegistrySpace registrySpace) {
 	List<ComponentDescription> cResponse = getAuthenticatedResource(
 		getResource().path("/registry/components").queryParam(
-			USERSPACE_PARAM, "" + userSpace)).accept(
+			REGISTRY_SPACE_PARAM, registrySpace.name())).accept(
 		MediaType.APPLICATION_XML).get(COMPONENT_LIST_GENERICTYPE);
 	Collections.sort(cResponse, descriptionComparator);
@@ -128,5 +130,5 @@
 
     private void registerProfiles(List<Thread> ts, int size,
-	    final List<String> errors, boolean userSpace)
+	    final List<String> errors, RegistrySpace registrySpace)
 	    throws InterruptedException {
 	for (int i = 0; i < size; i++) {
@@ -134,7 +136,7 @@
 	    LOG.debug("Profile {} should be registered in {} and {}",
 		    new Object[] { i + 1000,
-			    userSpace ? "user space" : "public space",
+			    registrySpace.name(),
 			    shouldDelete ? "ALSO DELETED" : "not deleted" });
-	    Thread thread = createThread("/registry/profiles/", userSpace,
+	    Thread thread = createThread("/registry/profiles/", registrySpace,
 		    "Test Profile" + (i + 1000), shouldDelete,
 		    RegistryTestHelper.getTestProfileContent(), errors);
@@ -144,5 +146,5 @@
 
     private void registerComponents(List<Thread> ts, int size,
-	    final List<String> errors, boolean userSpace)
+	    final List<String> errors, RegistrySpace registrySpace)
 	    throws InterruptedException {
 	for (int i = 0; i < size; i++) {
@@ -150,7 +152,7 @@
 	    LOG.debug("Component {} should be registered in {} and {}",
 		    new Object[] { i + 1000,
-			    userSpace ? "user space" : "public space",
+			    registrySpace.name(),
 			    shouldDelete ? "ALSO DELETED" : "not deleted" });
-	    Thread thread = createThread("/registry/components/", userSpace,
+	    Thread thread = createThread("/registry/components/", registrySpace,
 		    "Test Component" + (i + 1000), shouldDelete,
 		    RegistryTestHelper.getComponentTestContent(), errors);
@@ -159,5 +161,5 @@
     }
 
-    private Thread createThread(final String path, final boolean userSpace,
+    private Thread createThread(final String path, final RegistrySpace registrySpace,
 	    final String name, final boolean alsoDelete, InputStream content,
 	    final List<String> errors) throws InterruptedException {
@@ -176,6 +178,5 @@
 		    // System.out.println("THREAD STARTED"+Thread.currentThread().getName());
 		    RegisterResponse registerResponse = getAuthenticatedResource(
-			    getResource().path(path).queryParam(
-				    USERSPACE_PARAM, "" + userSpace)).type(
+			    getResource().path(path)).type(
 			    MediaType.MULTIPART_FORM_DATA).post(
 			    RegisterResponse.class, form);
@@ -188,5 +189,5 @@
 			    + "] REGISTERING DESCRIPTION " + name + " "
 			    + registerResponse.getDescription().getId()
-			    + (Boolean.valueOf(userSpace) ? " userspace" : "")
+			    + registrySpace.name()
 			    + (alsoDelete ? " alsoDelete" : ""));
 		    if (alsoDelete) {
@@ -197,6 +198,5 @@
 				+ " "
 				+ registerResponse.getDescription().getId()
-				+ (Boolean.valueOf(userSpace) ? " userspace "
-					: "")
+				+ registrySpace.name()
 				+ (alsoDelete ? " alsoDelete" : ""));
 			ClientResponse response = getAuthenticatedResource(
@@ -205,6 +205,5 @@
 						+ registerResponse
 							.getDescription()
-							.getId()).queryParam(
-					USERSPACE_PARAM, "" + userSpace))
+							.getId()))
 				.delete(ClientResponse.class);
 			if (response.getStatus() != 200) {
Index: /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/MDValidatorTest.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/MDValidatorTest.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/MDValidatorTest.java	(revision 5549)
@@ -4,11 +4,11 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryFactory;
-import clarin.cmdi.componentregistry.ComponentStatus;
-import clarin.cmdi.componentregistry.MDMarshaller;
+import clarin.cmdi.componentregistry.OwnerUser;
+import clarin.cmdi.componentregistry.RegistrySpace;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
-import clarin.cmdi.componentregistry.impl.database.ComponentRegistryTestDatabase;
 import clarin.cmdi.componentregistry.model.ComponentDescription;
 import clarin.cmdi.componentregistry.model.ProfileDescription;
-
+import clarin.cmdi.componentregistry.model.RegistryUser;
 import java.io.ByteArrayInputStream;
 import java.io.InputStream;
@@ -17,9 +17,8 @@
 
 import org.junit.Before;
+import org.junit.Ignore;
 import org.junit.Test;
 import org.springframework.beans.factory.annotation.Autowired;
-import org.springframework.jdbc.core.JdbcTemplate;
-
-import static org.junit.Assert.*;
+
 
 /**
@@ -31,20 +30,29 @@
 
     @Autowired
-    private ComponentRegistryFactory componentRegistryFactory;
-    private ComponentRegistry publicRegistry;
-
+    private ComponentRegistryFactory componentRegistryFactory; 
+    @Autowired
+    private ComponentRegistry testRegistry;
+    
+    private RegistryUser user;
+   
+    
     @Before
-    public void setUp() throws TransformerException {
-	publicRegistry = componentRegistryFactory.getPublicRegistry();
-    }
-
-    @Test
-    public void testValidateSucces() {
-	MDValidator validator = getValidProfileValidator();
-	assertTrue(validator.validate());
-    }
-
-    @Test
-    public void testValidateIllegalComponentAttributeName() {
+    @Override
+    public void setUp() throws TransformerException, UserUnauthorizedException {
+        testRegistry = componentRegistryFactory.getPublicRegistry();
+        user = componentRegistryFactory.getOrCreateUser(DummyPrincipal.DUMMY_CREDENTIALS);
+    }
+    
+   
+
+    @Test
+    public void testValidateSucces() throws UserUnauthorizedException{
+	MDValidator validator = this.getValidProfileValidator();
+        boolean result = validator.validate();
+	assertTrue(result);
+    }
+
+    @Test 
+    public void testValidateIllegalComponentAttributeName() throws UserUnauthorizedException{
 	String profileContent = "";
 	profileContent += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
@@ -93,6 +101,6 @@
 
 	ProfileDescription desc = ProfileDescription.createNewDescription();
-	MDValidator validator = new MDValidator(input, desc, publicRegistry,
-		null, publicRegistry, marshaller);
+        
+	MDValidator validator = new MDValidator(input, desc, testRegistry, marshaller);
 	assertFalse(validator.validate());
 	assertEquals(4, validator.getErrorMessages().size());
@@ -115,14 +123,15 @@
 
 	ProfileDescription desc = ProfileDescription.createNewDescription();
-	MDValidator validator = new MDValidator(input, desc, publicRegistry,
-		null, publicRegistry, marshaller);
-	assertFalse(validator.validate());
-	assertTrue(validator
-		.getErrorMessages()
-		.get(0)
-		.startsWith(MDValidator.COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR));
-    }
-
-    @Test
+        desc.setPublic(true);
+	MDValidator validator = new MDValidator(input, desc, testRegistry, marshaller);
+	assertFalse(validator.validate());
+	assertTrue(validator
+		.getErrorMessages()
+		.get(0)
+		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_ERROR));
+        //
+    }
+
+    @Test  
     public void testValidateComponentIdNotRegistered() throws Exception {
 	String id1 = "component1";
@@ -144,25 +153,22 @@
 	profileContent += "</CMD_ComponentSpec>";
 
-	// Ids not registered will return two errors. One for each id
-	ProfileDescription desc = ProfileDescription.createNewDescription();
+	// Ids not registered. will return 2 errors: one per each id.
+	ProfileDescription desc = ProfileDescription.createNewDescription();
+        desc.setPublic(true);
 	MDValidator validator = new MDValidator(new ByteArrayInputStream(
-		profileContent.getBytes()), desc, publicRegistry, null,
-		publicRegistry, marshaller);
-	assertFalse(validator.validate());
-	assertEquals(2, validator.getErrorMessages().size());
-	assertTrue(validator
-		.getErrorMessages()
-		.get(0)
-		.startsWith(MDValidator.COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR));
-	assertTrue(validator
-		.getErrorMessages()
-		.get(1)
-		.startsWith(MDValidator.COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR));
-
-	// id1 will be added and therefore only id2 is not registered
-	RegistryTestHelper.addComponent(publicRegistry, id1);
+		profileContent.getBytes()), desc, testRegistry, marshaller);
+	assertFalse(validator.validate());
+	assertEquals(1, validator.getErrorMessages().size());
+	assertTrue(validator
+		.getErrorMessages()
+		.get(0)
+		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_ERROR));
+	
+
+	// id1 will be added as public and therefore only id2 is not registered
+	RegistryTestHelper.addComponent(testRegistry, id1, true);
 	validator = new MDValidator(new ByteArrayInputStream(
-		profileContent.getBytes()), desc, publicRegistry, null,
-		publicRegistry, marshaller);
+		profileContent.getBytes()), desc, testRegistry
+                , marshaller);
 	assertFalse(validator.validate());
 	assertEquals(1, validator.getErrorMessages().size());
@@ -170,11 +176,10 @@
 		.getErrorMessages()
 		.get(0)
-		.startsWith(MDValidator.COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR));
-
-	// id2 is added, no more errors shoud be return
-	RegistryTestHelper.addComponent(publicRegistry, id2);
+		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_ERROR));
+
+	// id2 is added as public, no more errors shoud be return
+	RegistryTestHelper.addComponent(testRegistry, id2, true);
 	validator = new MDValidator(new ByteArrayInputStream(
-		profileContent.getBytes()), desc, publicRegistry, null,
-		publicRegistry, marshaller);
+		profileContent.getBytes()), desc, testRegistry, marshaller);
 	assertTrue("component is registered should be valid now",
 		validator.validate());
@@ -183,10 +188,7 @@
 
     @Test
-    public void testValidateUserRegistry() throws Exception {
+    public void testValidateBaseAndUserRegistry() throws Exception {
 	String id1 = "component1";
 	String id2 = "component2";
-	ComponentRegistry userRegistry = componentRegistryFactory
-		.getComponentRegistry(ComponentStatus.PRIVATE, null,
-			DummyPrincipal.DUMMY_CREDENTIALS);
 
 	String profileContent = "";
@@ -205,20 +207,28 @@
 	profileContent += "</CMD_ComponentSpec>";
 
+        // Public Registry
 	ProfileDescription desc = ProfileDescription.createNewDescription();
 	MDValidator validator = new MDValidator(new ByteArrayInputStream(
-		profileContent.getBytes()), desc, userRegistry, userRegistry,
-		publicRegistry, marshaller);
-	assertFalse(validator.validate());
-	assertEquals(2, validator.getErrorMessages().size());
+		profileContent.getBytes()), desc, testRegistry, marshaller);
+	assertFalse(validator.validate());
+	assertEquals(1, validator.getErrorMessages().size()); // the exception is thrown and propagated on the first non-registered component
 	assertTrue(validator.getErrorMessages().get(0)
 		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_ERROR));
-	assertTrue(validator.getErrorMessages().get(1)
-		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_ERROR));
-
-	RegistryTestHelper.addComponent(userRegistry, id1);
-	RegistryTestHelper.addComponent(publicRegistry, id2);
+        
+	
+        // registering publically the first component
+	RegistryTestHelper.addComponent(testRegistry, id1, true);
+        validator = new MDValidator(new ByteArrayInputStream(
+		profileContent.getBytes()), desc, testRegistry, marshaller);
+        assertFalse(validator.validate());
+	assertEquals(1, validator.getErrorMessages().size()); // the exception is thrown on the second non-registered component
+	assertTrue(validator.getErrorMessages().get(0)
+		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_ERROR));
+        
+        
+        
+	RegistryTestHelper.addComponent(testRegistry, id2, false);
 	validator = new MDValidator(new ByteArrayInputStream(
-		profileContent.getBytes()), desc, publicRegistry, null,
-		publicRegistry, marshaller);
+		profileContent.getBytes()), desc, testRegistry, marshaller);
 	assertFalse(validator.validate());
 	assertEquals(1, validator.getErrorMessages().size());
@@ -226,10 +236,16 @@
 		.getErrorMessages()
 		.get(0)
-		.startsWith(MDValidator.COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR));
-
+		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_IN_APPROPRIATE_SPACE_ERROR));
+        
+        
+        // make it user registry
+        testRegistry.setRegistryOwner(new OwnerUser(user.getId()));
+        testRegistry.setRegistrySpace(RegistrySpace.PRIVATE);       
+	
+        
 	validator = new MDValidator(new ByteArrayInputStream(
-		profileContent.getBytes()), desc, userRegistry, userRegistry,
-		publicRegistry, marshaller);
-	assertTrue(validator.validate());
+		profileContent.getBytes()), desc, testRegistry,  marshaller);
+        Boolean result =validator.validate(); 
+	assertTrue(result);
 	assertEquals(0, validator.getErrorMessages().size());
     }
@@ -254,6 +270,5 @@
 	ComponentDescription desc = ComponentDescription.createNewDescription();
 	MDValidator validator = new MDValidator(new ByteArrayInputStream(
-		content.getBytes()), desc, publicRegistry, null,
-		publicRegistry, marshaller);
+		content.getBytes()), desc, testRegistry, marshaller);
 	assertFalse(validator.validate());
 	assertEquals(1, validator.getErrorMessages().size());
@@ -261,10 +276,9 @@
 		.getErrorMessages()
 		.get(0)
-		.startsWith(MDValidator.COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR));
-
-	RegistryTestHelper.addComponent(publicRegistry, id1);
+		.startsWith(MDValidator.COMPONENT_NOT_REGISTERED_ERROR));
+
+	RegistryTestHelper.addComponent(testRegistry, id1, true);
 	validator = new MDValidator(
-		new ByteArrayInputStream(content.getBytes()), desc,
-		publicRegistry, null, publicRegistry, marshaller);
+		new ByteArrayInputStream(content.getBytes()), desc,testRegistry, marshaller);
 	assertTrue(validator.validate());
 	assertEquals(0, validator.getErrorMessages().size());
@@ -280,6 +294,5 @@
 
 	ProfileDescription desc = ProfileDescription.createNewDescription();
-	MDValidator validator = new MDValidator(input, desc, publicRegistry,
-		null, publicRegistry, marshaller);
+	MDValidator validator = new MDValidator(input, desc, testRegistry,marshaller);
 
 	// Spec is created during validation, before it should be null
@@ -309,6 +322,7 @@
 	InputStream input = new ByteArrayInputStream(profileContent.getBytes());
 	ProfileDescription desc = ProfileDescription.createNewDescription();
-	MDValidator validator = new MDValidator(input, desc, publicRegistry,
-		null, publicRegistry, marshaller);
+        desc.setPublic(true);
+        desc.setName("test_name");
+	MDValidator validator = new MDValidator(input, desc, testRegistry, marshaller);
 	return validator;
     }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/RegistryTestHelper.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/RegistryTestHelper.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/RegistryTestHelper.java	(revision 5549)
@@ -16,5 +16,7 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.DatesHelper;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
 import clarin.cmdi.componentregistry.MDMarshaller;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
 import clarin.cmdi.componentregistry.model.Comment;
@@ -27,8 +29,4 @@
 import java.io.InputStreamReader;
 
-import javax.xml.transform.TransformerException;
-
-import org.junit.Before;
-import org.junit.BeforeClass;
 import org.springframework.beans.factory.annotation.Autowired;
 
@@ -46,22 +44,23 @@
     }
 
-    public static ComponentDescription addComponent(ComponentRegistry testRegistry, String id) throws ParseException, JAXBException {
-	return addComponent(testRegistry, id, getComponentTestContent());
-    }
-
-    public static ComponentDescription addComponent(ComponentRegistry testRegistry, String id, String content) throws ParseException,
+    public static ComponentDescription addComponent(ComponentRegistry testRegistry, String id, boolean isPublic) throws ParseException, JAXBException {
+	return addComponent(testRegistry, id, getComponentTestContent(), isPublic);
+    }
+
+    public static ComponentDescription addComponent(ComponentRegistry testRegistry, String id, String content, boolean isPublic) throws ParseException,
 	    JAXBException, UnsupportedEncodingException {
-	return addComponent(testRegistry, id, new ByteArrayInputStream(content.getBytes("UTF-8")));
-    }
-
-    private static ComponentDescription addComponent(ComponentRegistry testRegistry, String id, InputStream content) throws ParseException,
+	return addComponent(testRegistry, id, new ByteArrayInputStream(content.getBytes("UTF-8")), isPublic);
+    }
+
+    private static ComponentDescription addComponent(ComponentRegistry testRegistry, String id, InputStream content, boolean isPublic) throws ParseException,
 	    JAXBException {
 	ComponentDescription desc = ComponentDescription.createNewDescription();
 	desc.setCreatorName(DummyPrincipal.DUMMY_CREDENTIALS.getDisplayName());
-	desc.setUserId(DummyPrincipal.DUMMY_CREDENTIALS.getPrincipalName());
+        desc.setUserId(DummyPrincipal.DUMMY_PRINCIPAL.getName());
 	desc.setName(id);
 	desc.setDescription("Test Description");
 	desc.setId(ComponentDescription.COMPONENT_PREFIX + id);
 	desc.setHref("link:" + desc.getId());
+        desc.setPublic(isPublic);
 	CMDComponentSpec spec = marshaller.unmarshal(CMDComponentSpec.class, content, marshaller.getCMDComponentSchema());
 	testRegistry.register(desc, spec);
@@ -104,15 +103,15 @@
     }
 
-    public static ProfileDescription addProfile(ComponentRegistry testRegistry, String id) throws ParseException, JAXBException {
-	return addProfile(testRegistry, id, RegistryTestHelper.getTestProfileContent());
-    }
-
-    public static ProfileDescription addProfile(ComponentRegistry testRegistry, String id, String content) throws ParseException,
-	    JAXBException {
-	return addProfile(testRegistry, id, new ByteArrayInputStream(content.getBytes()));
-    }
-
-    private static ProfileDescription addProfile(ComponentRegistry testRegistry, String id, InputStream content) throws ParseException,
-	    JAXBException {
+    public static ProfileDescription addProfile(ComponentRegistry testRegistry, String id, boolean isPublic) throws ParseException, JAXBException, ItemNotFoundException {
+	return addProfile(testRegistry, id, RegistryTestHelper.getTestProfileContent(), isPublic);
+    }
+
+    public static ProfileDescription addProfile(ComponentRegistry testRegistry, String id, String content, boolean isPublic) throws ParseException,
+	    JAXBException, ItemNotFoundException {
+	return addProfile(testRegistry, id, new ByteArrayInputStream(content.getBytes()), isPublic);
+    }
+
+    private static ProfileDescription addProfile(ComponentRegistry testRegistry, String id, InputStream content, boolean isPublic) throws ParseException,
+	    JAXBException, ItemNotFoundException {
 	ProfileDescription desc = ProfileDescription.createNewDescription();
 	desc.setCreatorName(DummyPrincipal.DUMMY_CREDENTIALS.getDisplayName());
@@ -122,4 +121,5 @@
 	desc.setId(ProfileDescription.PROFILE_PREFIX + id);
 	desc.setHref("link:" + ProfileDescription.PROFILE_PREFIX + id);
+        desc.setPublic(isPublic);
 	CMDComponentSpec spec = marshaller.unmarshal(CMDComponentSpec.class, content, marshaller.getCMDComponentSchema());
 	testRegistry.register(desc, spec);
@@ -216,5 +216,5 @@
     }
 
-    public static Comment addComment(ComponentRegistry testRegistry, String id, String descriptionId, String principal) throws ParseException, JAXBException, ComponentRegistryException {
+    public static Comment addComment(ComponentRegistry testRegistry, String id, String descriptionId, String principal) throws ParseException, JAXBException, ComponentRegistryException, ItemNotFoundException,UserUnauthorizedException {
 	return addComment(testRegistry, RegistryTestHelper.getTestCommentContent(id, descriptionId), principal);
     }
@@ -222,5 +222,5 @@
     private static Comment addComment(ComponentRegistry testRegistry, InputStream content, String principal) throws ParseException,
 	    JAXBException,
-	    ComponentRegistryException {
+	    ComponentRegistryException, ItemNotFoundException,UserUnauthorizedException {
 	Comment spec = marshaller.unmarshal(Comment.class, content, null);
 	testRegistry.registerComment(spec, principal);
Index: /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/SanboxTest.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/SanboxTest.java	(revision 5549)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/SanboxTest.java	(revision 5549)
@@ -0,0 +1,170 @@
+/*
+ * To change this template, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package clarin.cmdi.componentregistry.rest;
+
+import clarin.cmdi.componentregistry.ComponentRegistry;
+import clarin.cmdi.componentregistry.ComponentRegistryFactory;
+import clarin.cmdi.componentregistry.impl.database.ComponentRegistryBeanFactory;
+import clarin.cmdi.componentregistry.impl.database.ComponentRegistryTestDatabase;
+import clarin.cmdi.componentregistry.model.Comment;
+import clarin.cmdi.componentregistry.model.ComponentDescription;
+import clarin.cmdi.componentregistry.model.ProfileDescription;
+import clarin.cmdi.componentregistry.model.RegisterResponse;
+import com.sun.jersey.api.client.ClientResponse;
+import com.sun.jersey.multipart.FormDataMultiPart;
+import javax.ws.rs.core.MediaType;
+import org.junit.Before;
+import org.junit.Test;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.jdbc.core.JdbcTemplate;
+
+import org.springframework.util.Assert;
+import static org.junit.Assert.*;
+/**
+ *
+ * @author olhsha
+ */
+public class SanboxTest extends
+	ComponentRegistryRestServiceTestCase {
+
+    @Autowired
+    private ComponentRegistryFactory componentRegistryFactory;
+    @Autowired
+    private ComponentRegistryBeanFactory componentRegistryBeanFactory;
+    @Autowired
+    private JdbcTemplate jdbcTemplate;
+    private ComponentRegistry baseRegistry;
+
+    @Before
+    public void init() {
+	ComponentRegistryTestDatabase.resetAndCreateAllTables(jdbcTemplate);
+	createUserRecord();
+	baseRegistry = componentRegistryFactory.getBaseRegistry(DummyPrincipal.DUMMY_CREDENTIALS);
+    }
+
+    private String expectedUserId(String principal) {
+	return getUserDao().getByPrincipalName(principal).getId().toString();
+    }
+
+    private ComponentDescription component1;
+    private ComponentDescription component2;
+    private ProfileDescription profile1;
+    private ProfileDescription profile2;
+    
+    private ComponentDescription component3;
+    private ProfileDescription profile3;
+    
+    private Comment profile1Comment1;
+    private Comment profile1Comment2;
+    private Comment component1Comment3;
+    private Comment component1Comment4;
+    
+    private Comment profile3Comment5;
+    private Comment component3Comment7;
+
+    private void fillUpPublicItems() throws Exception {
+        
+	profile1 = RegistryTestHelper.addProfile(baseRegistry, "profile2", true);
+	profile2 = RegistryTestHelper.addProfile(baseRegistry, "profile1", true);
+	component1 = RegistryTestHelper.addComponent(baseRegistry,
+		"component2", true);
+	component2 = RegistryTestHelper.addComponent(baseRegistry,
+		"component1", true);
+	profile1Comment2 = RegistryTestHelper.addComment(baseRegistry, "comment2",
+		ProfileDescription.PROFILE_PREFIX + "profile1",
+		"JUnit@test.com");
+	profile1Comment1 = RegistryTestHelper.addComment(baseRegistry, "comment1",
+		ProfileDescription.PROFILE_PREFIX + "profile1",
+		"JUnit@test.com");
+	component1Comment3 = RegistryTestHelper.addComment(baseRegistry, "comment3",
+		ComponentDescription.COMPONENT_PREFIX + "component1",
+		"JUnit@test.com");
+	component1Comment4 = RegistryTestHelper.addComment(baseRegistry, "comment4",
+		ComponentDescription.COMPONENT_PREFIX + "component1",
+		"JUnit@test.com");
+    }
+    
+    private void fillUpPrivateItems() throws Exception {
+	profile3 = RegistryTestHelper.addProfile(baseRegistry, "profile3", false);
+	component3 = RegistryTestHelper.addComponent(baseRegistry,
+		"component3", false);
+	profile3Comment5 = RegistryTestHelper.addComment(baseRegistry, "comment5",
+		ProfileDescription.PROFILE_PREFIX + "profile3",
+		"JUnit@test.com");
+	component3Comment7 = RegistryTestHelper.addComment(baseRegistry, "comment7",
+		ComponentDescription.COMPONENT_PREFIX + "component3",
+		"JUnit@test.com");
+    }
+    
+       @Test
+    public void testCreatePrivateComponentWithRecursion() throws Exception {
+        
+        fillUpPrivateItems();
+	// Create new componet
+	FormDataMultiPart form = createFormData(RegistryTestHelper
+		.getComponentTestContent());
+	ClientResponse cResponse = getAuthenticatedResource(getResource().path("/registry/components")).type(
+		MediaType.MULTIPART_FORM_DATA).post(ClientResponse.class, form);
+	assertEquals(ClientResponse.Status.OK.getStatusCode(),
+		cResponse.getStatus());
+	RegisterResponse response = cResponse.getEntity(RegisterResponse.class);
+	assertTrue(response.isRegistered());
+	ComponentDescription desc = (ComponentDescription) response
+		.getDescription();
+
+	// Re-define with self-recursion
+	String compContent = "";
+	compContent += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
+	compContent += "\n";
+	compContent += "<CMD_ComponentSpec isProfile=\"false\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
+	compContent += "    xsi:noNamespaceSchemaLocation=\"../../general-component-schema.xsd\">\n";
+	compContent += "    \n";
+	compContent += "    <Header/>\n";
+	compContent += "    \n";
+	compContent += "    <CMD_Component name=\"Nested\" CardinalityMin=\"1\" CardinalityMax=\"1\">\n";
+	compContent += "        <CMD_Element name=\"Availability\" ValueScheme=\"string\" />\n";
+	compContent += "        <CMD_Component ComponentId=\""
+		+ desc.getId()
+		+ "\" name=\"Recursive\" CardinalityMin=\"1\" CardinalityMax=\"1\" />\n";
+	compContent += "    </CMD_Component>\n";
+	compContent += "\n";
+	compContent += "</CMD_ComponentSpec>\n";
+
+	// Update component
+	form = createFormData(
+		RegistryTestHelper.getComponentContentAsStream(compContent),
+		"UPDATE DESCRIPTION!");
+	cResponse = getAuthenticatedResource(getResource().path(
+			"/registry/components/" + desc.getId() + "/update")).type(
+		MediaType.MULTIPART_FORM_DATA).post(ClientResponse.class, form);
+	assertEquals(ClientResponse.Status.OK.getStatusCode(),
+		cResponse.getStatus());
+	response = cResponse.getEntity(RegisterResponse.class);
+	assertFalse("Recursive definition should fail", response.isRegistered());
+	assertEquals("There should be an error message for the recursion", 1,
+		response.getErrors().size());
+	assertTrue(
+		"There error message should specify the point of recursion",
+		response.getErrors().get(0)
+			.contains("already contains " + desc.getId()));
+
+    }
+
+     private FormDataMultiPart createFormData(Object content) {
+	return createFormData(content, "My Test");
+    }
+
+    private FormDataMultiPart createFormData(Object content, String description) {
+	FormDataMultiPart form = new FormDataMultiPart();
+	form.field(IComponentRegistryRestService.DATA_FORM_FIELD, content,
+		MediaType.APPLICATION_OCTET_STREAM_TYPE);
+	form.field(IComponentRegistryRestService.NAME_FORM_FIELD, "Test1");
+	form.field(IComponentRegistryRestService.DESCRIPTION_FORM_FIELD,
+		description);
+	form.field(IComponentRegistryRestService.DOMAIN_FORM_FIELD, "My domain");
+	form.field(IComponentRegistryRestService.GROUP_FORM_FIELD, "TestGroup");
+	return form;
+    }
+}
